*********************************************************************
* Program.......: CGH_MAIN.PRG
* Date..........: 02/04/92
* Author........: Robert Lucas
* Notice........: Copyright 1991, All rights reserved
* Version.......: FoxPro, revision 2.0
* Prev Revision.:Sun  08-23-1992  21:38:56
* Last Revision.:Tue  06-07-1994  09:49:55
*
* Notes.........: Main calling program for 
*                 setting up parameters and defaults
*
*********************************************************************
WAIT '   Program Loading....' WINDOW NOWAIT
*--- Establish Program Environment


HIDE WINDOW ALL
ON SHUTDOWN QUIT
SET BELL OFF
SET BLINK OFF

IF _WINDOWS
   MODIFY WINDOW SCREEN COLOR RGB(0,0,0,128, 192, 192)
   MODIFY WINDOW SCREEN TITLE "CGH Oracle Monitor"
   SET CLOCK STATUS
   SET STATUS BAR ON
   SET MESSAGE TO ""
ELSE   
   SET CLOCK ON
   SET CLOCK TO 0, SCOLS() - 11
ENDIF
   
CLEAR
SET CONSOLE ON
SET CONFIRM OFF
SET DEBUG ON
SET DECIMALS TO 2
SET DELETE ON
SET ECHO OFF
SET ESCAPE OFF
SET EXCLUSIVE ON
SET FULLPATH OFF
SET HELP ON
SET NOTIFY OFF
SET REPROCESS TO AUTOMATIC
SET REFRESH TO 30
SET SAFETY OFF
SET STATUS OFF
SET TALK OFF
SET TALK WINDOW

STORE DTOC(DATE()) TO GCDATE

WAIT ' Setting System Parameters...' WINDOW NOWAIT

ON ERROR DO Cghfxerr WITH ERROR(), MESSAGE(), ;
    MESSAGE(1), SYS(16), LINENO(), SYS(102), ;
    SYS(100), SYS(101), LASTKEY(), ALIAS(), ;
    SYS(18), SYS(5), SYS(12), SYS(6), SYS(2003), ;
    WONTOP(), SYS(2011), SYS(2018)

SET FUNCTION  2 TO ''
SET FUNCTION  3 TO ''
SET FUNCTION  4 TO ''
SET FUNCTION  5 TO ''
SET FUNCTION  6 TO ''
SET FUNCTION  7 TO ''
SET FUNCTION  8 TO ''
SET FUNCTION  9 TO ''
SET FUNCTION 10 TO CHR(23)
ON KEY LABEL ALT-C DO Chk_calc
ON KEY LABEL ALT-D KEYBOARD DTOC(DATE())
SET PROCEDURE TO CGH_PROC

* Setup Global Variables required and used by
* all programs
*
DIMENSION g_prt(1)
DIMENSION g_colors(1)
g_prt(1) = "No Printer Setup" 
m.g_printer = ' '  
g_colors = "None Available"

DIMENSION g_ports(4)
g_ports(1) = "LPT1"
g_ports(2) = "LPT2"
g_ports(3) = "COM1"
g_ports(4) = "COM2"
g_def_port = "LPT1"


Button   = SPACE(1)
top      = 0
bot      = 0
m.gnpushmenu = 0
add_flag = .F.
done     = .F.
upd_flag = .F.
m.f4     = .f.
m.f4x    = .f.
g_date   = DATE()
m.g_error = .f.

DIMENSION ga_Windows(1)
ga_Windows = ""

m.quitting    = .f.
m.gwindow     = " "
m.gwindowpad  = ""
m.gcnextprog  = ""
m.glRestState = .f.
m.glEditMode  = .f.
m.go_userid   = SPACE(20)
m.go_passwd   = SPACE(20)
m.go_source   = SPACE(20)
m.go_type     = SPACE(20)
m.go_handle   = 0

CREATE table SaveStat ;
         (cWindow C(10), mMemvars M(10), cOldAlias C(10),;
          cOldOrder C(10), cSaveID C(9))
use savestat alias savestate
          
_DIARYDATE = DATE()

IF FILE('CGH_HELP.DBF')
   m.g_helpfile = "CGH_HELP.DBF"

   IF !EMPTY(m.g_helpfile) AND FILE(m.g_helpfile)
      SET HELP TO (m.g_helpfile)
      SET HELP ON
      SET TOPIC TO UPPER(TOPIC) = UPPER(VARREAD())
      ON KEY LABEL F1 HELP
   ENDIF

ENDIF   

WAIT 'Initializing system...' WINDOW NOWAIT
SET LIBRARY TO (SYS(2004) + "JKEY.FLL")
SET LIBRARY TO (SYS(2004) + "FOXTOOLS.FLL") ADDITIVE
SET LIBRARY TO (SYS(2004) + "FPSQL.FLL") ADDITIVE

DO Disp_main
g_main_disp = 'disp_main'

* WAIT 'Preparing User Validation...' WINDOW NOWAIT
* m.g_userid     = ''
* m.g_inits      = ''
* m.g_superuser  = ''
* m.g_acc_lvl    = 2
* STORE .T. TO m.ok

* DO PASS_ENT.SPR WITH g_userid, g_superuser, g_inits, g_acc_lvl, .f., ok,;
                     "PASSWD", "USER_ID", "PASSWD"


read_type = "Foundation"
* read_type = "Loop"
DO CGH_MENU.MPR
      
*
* Allow the option of using a foundation read or
* a do while loop
*
* the foundation read allows access to the calculator if
* it is selected
*
* the do while loop save a read level
*

IF TYPE('Read_type') # 'C'
   read_type = 'Foundation'
ENDIF
   
DO CASE
   CASE Read_type = 'Foundation'
        READ WHEN Set_run();
             VALID Myhandler() WITH 'Calculator'

   CASE Read_type = 'Loop'
        DO WHILE !Done

           IF !_WINDOWS AND SET('SYSMENU') # 'AUTOMATIC'
              SET SYSMENU AUTOMATIC
           ENDIF

           IF !Done 
              
              IF m.g_error
                 m.g_error = .f.
                 SET SYSMENU ON
                 POP MENU _MSYSMENU
              ENDIF
               
              ACTIVATE MENU _MSYSMENU
           ENDIF
   
        ENDDO
ENDCASE        

CLOSE DATABASES
= DBDISCONN(m.go_handle)
SET SYSMENU TO DEFAULT
SHOW WINDOW Command
ON ERROR

IF FILE(SYS(2004) + 'FOXHELP.DBF')
   SET HELP TO SYS(2004) + 'FOXHELP.DBF'
ENDIF
   
CLEAR ALL
SET EXCLUSIVE ON
ERASE TEMP.FXP
SET LIBRARY TO
ON KEY LABEL F1 HELP
RETURN


*
* EOM: CGH_MAIN.PRG
*

   

FUNCTION Endloop
   IF !_WINDOWS
   
      IF SET('SYSMENU') # 'AUTOMATIC'
         SET SYSMENU AUTOMATIC
      ENDIF
      
   ENDIF   

   IF !Done 
      
      IF !_WINDOWS
         ACTIVATE MENU _MSYSMENU
      ENDIF
         
   ENDIF
   
   RETURN Done
   
   
   
PROCEDURE Chk_calc
   IF WEXIST("_CALCTMP")
      HIDE WINDOW "Calculator"
      CLEAR READ
      RETURN
   ENDIF
      
   IF UPPER(WONTOP()) = "CALCULATOR"
      HIDE WINDOW "Calculator"
      RETURN
   ENDIF
       
   IF RDLEVEL() = 0
      IF UPPER(WONTOP()) = "CALCULATOR"
         HIDE WINDOW "Calculator"
         
      ELSE   
         DEFINE WINDOW _CALCTMP FROM 100, 100 TO 103, 108
         ACTIVATE WINDOW _CALCTMP
         m.tmp = " "
         @ 0, 0 GET m.tmp 
         READ ACTIVATE Act_calc() DEACTIVATE Close_calc() CYCLE
         RELEASE WINDOW _CALCTMP
         SET SYSMENU AUTOMATIC
      ENDIF
      
   ELSE
      IF WEXIST("_CALCTMP") 
         HIDE WINDOW "Calculator"
         CLEAR READ
         RELEASE WINDOW _CALCTMP
         SET SYSMENU AUTOMATIC
      ELSE   
         ACTIVATE WINDOW "Calculator"
      ENDIF
            
   ENDIF
   
   RETURN

         
FUNCTION Act_calc
   IF PROPER(WLAST()) = "Calculator"
      CLEAR READ
   ELSE   
      ACTIVATE WINDOW Calculator
   ENDIF  
    
   RETURN
   
   
FUNCTION Close_calc
   IF !WVISIBLE("Calculator") 
      CLEAR READ
   ELSE
      RETURN .F.   
   ENDIF   
         

PROCEDURE Set_run
   IF !_WINDOWS
      ACTIVATE MENU _MSYSMENU
   ENDIF
      
   RETURN
         


   
PROCEDURE Disp_main
   * define the pticker window here so that if an error
   * occurs, the error routine (which releases all windows)
   * can redefine this window
   
   POP KEY ALL

   SET FUNCTION 10 TO CHR(23)
   ON KEY LABEL ALT-C DO Chk_calc
   ON KEY LABEL ALT-D KEYBOARD DTOC(DATE())
   
   DEFINE WINDOW pticker    FROM SROWS() - 3,00 TO SROWS()-1,79;
          DOUBLE FLOAT SHADOW COLOR SCHEME 11
          
   m.title = " " + Longdate(DATE()) + " "
   DO Mainwin.spr with m.title
   RETURN


PROCEDURE SetOpts

   IF m.go_handle < 1
      DO Standby with "No connection to a database.;Cannot set options."
      RETURN
   ENDIF
   
   WAIT WINDOW "Updating Option Settings..." NOWAIT
   = Fxuse("SYSTEM")
   GO TOP
   SCATTER MEMVAR
   
   m.option = "Asynchronous" 
   m.result = DBSetOpt(m.go_handle, m.option, IIF(m.asynch, 1, 0))
   
   IF m.result > 0
      m.option = "BatchMode"
      m.result = DBSetOpt(m.go_handle, m.option, IIF(m.batch, 1, 0))
   ENDIF

   IF m.result > 0
      m.option = "Browse"
      m.result = DBSetOpt(m.go_handle, m.option, IIF(m.browse, 1, 0))
   ENDIF
      
   IF m.result > 0
      m.option = "CancelOnEsc"
      m.result = DBSetOpt(m.go_handle, m.option, IIF(m.cancel, 1, 0))
   ENDIF
      
   IF m.result > 0
      m.option = "ConnTimeout"
      m.result = DBSetOpt(0, m.option, INT(m.c_timeout))
   ENDIF
      
   IF m.result > 0
      m.option = "DispError"
      m.result = DBSetOpt(m.go_handle, m.option, IIF(m.disperr, 1, 0))
   ENDIF
      
   IF m.result > 0
      m.option = "GenTimeout"
*      m.result = DBSetOpt(m.go_handle, m.option, INT(m.g_timeout))
   ENDIF
      
   IF m.result > 0
      m.option = "UseMemoSize"
      m.result = DBSetOpt(m.go_handle, m.option, INT(m.memosize))
   ENDIF
      
   IF m.result > 0
      m.option = "UseTables"
      m.result = DBSetOpt(m.go_handle, m.option, IIF(m.usetables = 2, 1, 0))
   ENDIF
      
   IF m.result < 1
   
      IF m.result = -1
         DO Con_err.spr WITH m.go_handle, m.option
      ELSE
         DO Con_err.spr WITH 0, m.result, m.option
      ENDIF
      
   ELSE
      WAIT WINDOW "All options successfully set." NOWAIT   
   ENDIF     
         


   * EOF: CGH_MAIN.PRG

*!*********************************************************************
*!
*!       Function: MYHANDLER()
*!
*!
*!*********************************************************************

*   The Foundation READ terminates when this routine returns .T.
*   As long as it returns .F., execution of the Foundation READ will
*   continue

FUNCTION myhandler
PRIVATE m.temp, m.x

IF done
   RETURN .T.				  && Only when 'Exit' is selected
ENDIF						  && from the menu.

IF LEN(tobedone) > 0		  && Launches an SPR which was
   m.temp = tobedone		  && specified from the menu
   tobedone = ""
   DO (m.temp)
   RETURN .F.
ENDIF

RETURN .F.


FUNCTION myhandler

   PRIVATE m.lccurrspr, m.llretval

   llretval   = .F.                         && initialize our RETURN VALUE
   m.quitting = .f.
   
   IF m.done       			                && 'quit' chosen FROM MENU
      RETURN .T.
   ENDIF

   IF !EMPTY(gcnextprog)                  && SPR was specified FROM the MENU
      m.lccurrspr = gcnextprog
      gcnextprog = ""
      DO (m.lccurrspr)
      RETURN .F.
   ENDIF

   *--
   * following CASE statement uses window naming conventions rather than
   * hard coded lists as in EX1.PRG
   *--

   DO CASE                               	 && handles ALL OTHERWISE cases
      CASE UPPER(LEFT(WONTOP(),2)) = "WR"    && A READ WINDOW is foremost
         m.lcprogram = TRIM(SUBSTR(WONTOP(),3,8))+".SPR"
         DO (m.lcprogram)
         
      CASE UPPER(LEFT(WONTOP(),2)) = "WC"    && Control WINDOW is foremost
         * Following code finds the foremost application window,
         * then launches the .SPR which controls that window.  If none
         *  is found, nothing happens.
         * It is executed when the control panel is foremost.
         *--
         m.lcprogram = currspr()             && UDF TO FIND current READ
         
         IF !EMPTY(m.lcprogram)              && BLANK IF no READ WINDOW
            DO (m.lcprogram)
         ENDIF
         
   ENDCASE
   
   RETURN llretval



   *!*****************************************************************************
   *!
   *!       Function: CURRSPR
   *!
   *!
   *!*****************************************************************************
FUNCTION currspr
   *
   * Finds the current read and returns the SPR to do
   * If there is no read window it returns a blank
   *
   PRIVATE m.lcprogram, m.lcwindow
   m.lcprogram = ""
   m.lcwindow = UPPER(WCHILD("",0))
 
   DO WHILE !EMPTY (m.lcwindow)
   
      IF UPPER(LEFT(m.lcwindow,2)) = "WR"
         m.lcprogram = TRIM(SUBSTR(m.lcwindow,3,8))+".SPR"
      ENDIF
      
      m.lcwindow = UPPER(WCHILD("",1))
   ENDDO
 
   RETURN m.lcprogram
   
   
   
   *!*****************************************************************************
   *!
   *!       Function: CURRWR
   *!
   *!*****************************************************************************
FUNCTION currwr
   *
   * Finds the current read and returns the window name.
   * If there is no read window it returns a blank
   *
   PRIVATE m.lcwindow, m.lcreadwind
   m.lcwindow = UPPER(WCHILD("",0))
   
   DO WHILE !EMPTY (m.lcwindow)
   
      IF UPPER(LEFT(m.lcwindow,2)) = "WR"
         m.lcreadwind = m.lcwindow
      ENDIF
      
      m.lcwindow = UPPER(WCHILD("",1))
   ENDDO
   
   RETURN m.lcreadwind
   
   
   
*!*********************************************************************
*!
*!      Procedure: EFFACE
*!
*!
*!*********************************************************************

*  Routine to decide whether or not to release the control panel.
*
*  EFFACE is called when either the 'Quit' button has been pressed
*  or a READ window has been manually closed by clicking in the
*  close box or by selecting 'Close' from the 'File' menu.
*
*  It looks through all the windows that are open, from back to front.
*  If it finds any of the user application windows (which
*  will require the control panel) it simply exits.
*
*  Otherwise, it concludes we're finished with the control panel
*  and releases it.
*
*  The surrounding application insures that WONTOP() is the control panel.

PROCEDURE efface
PRIVATE m.x

m.x = WCHILD("",0)
DO WHILE LEN(m.x) > 0
   IF INLIST(m.x, "CUST","PARTS","INV","SMAN")
      RETURN
   ENDIF
   m.x = WCHILD("",1)
ENDDO
RELEASE WINDOW (WONTOP())



*!*********************************************************************
*!
*!      Procedure: STOPREAD
*!
*!*********************************************************************

*	Routine executed when the DEACTIVATE clause of one of the
*	application READs is triggered.  If it returns .T., the
*	READ terminates.  Otherwise if it returns .F., the READ
*	continues.
*
*	NOTE:  the value of 'quitting' may have been set to .T. prior to
*	entering this routine if the user pressed the 'Quit' button to
*	terminate the READ.

FUNCTION stopread
PARAMETER m.window

IF m.quitting OR !WVISIBLE(m.window)			&& Did window get closed manually?
   quitting = .T.					&& and act as if 'Quit' was pressed
ENDIF

RETURN quitting OR !WREAD()		&& Stop if 'quitting', or
									&& if WONTOP() isn't a READ window.


*!*****************************************************************
*!
*!      Procedure: MHIT
*!
*!*****************************************************************
PROCEDURE mhit
	PARAMETER lcnewprog
	*
	*	If an application READ is already active,
	*	execute CLEAR READ.  This causes the active
	*	application READ to terminate as soon as
	*	the menu processing routine is complete and
	*	also requests that the foundation READ be teminated.
	*	The active application READ terminates first
	*	and control passes back to the foundation READ.
	*	Since it has also been CLEARed, it executes
	*	its VALID routine.  This VALID routine, noting
	*	that the PUBLIC variable 'tobedone' has been
	*	assigned a value, launches the new application
	*	which has been requested.
	*
	
	IF OCCURS(',', lcnewprog)>0
		STORE SUBSTR(lcnewprog,AT(',',lcnewprog)+1, LEN(lcnewprog));
			TO lcfile
		STORE SUBSTR(lcnewprog,1,AT(',',lcnewprog)-1);
			TO lcnewprog
	ELSE
		STORE "" TO lcfile
	ENDIF
	IF RDLEVEL() > 1
		m.gcnextprog = lcnewprog
		IF WONTOP('help')
			RELEASE WINDOW HELP
		ENDIF
		CLEAR READ
	ELSE
		*
		*	If no other application is running,
		*	just start the requested application
		*
		IF LEN(ALLTRIM(lcfile))>0
			DO (lcnewprog) WITH lcfile
		ELSE
			DO (lcnewprog)
		ENDIF
	ENDIF
	
RETURN


	
IF RDLEVEL() > 1
   tobedone = prog
   CLEAR READ
ELSE
*
*	If no other application is running,
*	just start the requested application
*
   DO (prog)
ENDIF



*!*****************************************************************
*!
*!      Procedure: MEXIT
*!
*!*****************************************************************
PROCEDURE mexit
dropdead = .T.
CLEAR READ ALL


PROCEDURE AddMbar
   PARAMETER WindowName, Prompt
   
   PRIVATE i, x, foundit
   
   IF PARAMETERS() = 1
      m.prompt = PROPER(WTITLE(m.WindowName))
   ENDIF
   
   IF PARAMETERS() = 0
      m.WindowName = WONTOP()
      m.prompt = PROPER(WTITLE(m.WindowName))
   ENDIF
   
   m.prompt = PROPER(m.prompt)
   foundit = .f.
    
   FOR i = CNTBAR(m.gwindowpad) TO 1 STEP -1
 
      IF PRMBAR(m.gwindowpad,GETBAR(m.gwindowpad,i)) = m.prompt
         foundit = .t.
         EXIT
      ENDIF
      
   ENDFOR
      
   IF !foundit
      IF EMPTY(ga_Windows[1])
         x = 1
      ELSE   
         x = ALEN(ga_Windows) + 1
         DIMENSION ga_Windows[x]
      ENDIF
         
      ga_Windows[x] = m.prompt
      
      IF GETBAR(m.gwindowpad,CNTBAR(m.gwindowpad)) < 0
         i = CNTBAR(m.gwindowpad) + 1
      ELSE
         i = GETBAR(m.gwindowpad,CNTBAR(m.gwindowpad)) + 1
      ENDIF
   
      DEFINE BAR i OF (m.gwindowpad) PROMPT m.prompt AFTER _mlast
	  ON SELECTION BAR i OF (m.gwindowpad) ACTIVATE WINDOW &WindowName
   ENDIF

   RETURN
   
   
   
PROCEDURE RemMBar
   PARAMETER WindowName, Prompt
   
   PRIVATE i, x

   IF PARAMETERS() = 1
      m.prompt = PROPER(m.WindowName)
   ENDIF
   
   IF PARAMETERS() = 0
      m.WindowName = WONTOP()
      m.prompt = PROPER(WTITLE(m.WindowName))
   ENDIF
   
   m.prompt = PROPER(m.prompt)
   x = ASCAN(ga_Windows, m.prompt)
   
   IF x > 0
      = ADEL(ga_Windows, x)
      
      IF x > 1
         DIMENSION ga_Windows[x - 1]
      ELSE
         ga_Windows = ""
      ENDIF
         
   ENDIF
         
   FOR i = CNTBAR(m.gwindowpad) TO 1 STEP -1
 
      IF PRMBAR(m.gwindowpad, GETBAR(m.gwindowpad,i)) = m.prompt
         RELEASE BAR GETBAR(m.gwindowpad, i) OF (m.gwindowpad)
         EXIT
      ENDIF
      
   ENDFOR

   RELEASE WINDOW (WindowName)

   IF USED("SaveState")
      SELECT SaveState
         
      LOCATE FOR UPPER(SaveState.cWindow) = UPPER(m.WindowName)
   
      IF FOUND()
         DELETE
      ENDIF      
   ENDIF       
         
   RETURN
   
   
   
PROCEDURE RestState

   PARAMETER tcWindow
   
   PRIVATE jcSaveAlias, jcSaveOrder, jcSaveID
   
   jcSaveAlias = ALIAS()
   jcSaveOrder = ORDER()
   
   IF !USED("SaveState")
      RETURN
   ELSE
      SELECT SaveState   
   ENDIF       
   
   LOCATE FOR UPPER(SaveState.cWindow) = UPPER(m.tcWindow)
   
   IF FOUND()
      RESTORE FROM MEMO SaveState.mMemvars ADDITIVE
      glEditMode  = .t.
      glRestState = .t.
      jcSaveAlias = TRIM(SaveState.cOldAlias)
      jcSaveOrder = TRIM(SaveState.cOldOrder)
      DELETE
      SHOW GETS 
    ELSE
      glEditMode  = .f.
      glRestState = .f.
    ENDIF      
         
    SELECT (jcSaveAlias)
    SET ORDER TO (jcSaveOrder)
    RETURN           
         


PROCEDURE SaveState

   PARAMETER tcWindow
   
   PRIVATE jcSaveAlias, jcSaveOrder, jcSaveID
   
   jcSaveAlias = ALIAS()
   jcSaveOrder = ORDER()
   m.cWindow   = m.tcWindow
   m.cOldAlias = m.jcSaveAlias
   m.cOldOrder = m.jcSaveOrder
   m.cSaveID   = ""
   
   IF !USED("SaveState")
      CREATE CURSOR SaveState ;
         (cWindow C(10), mMemvars M(10), cOldAlias C(10),;
          cOldOrder C(10), cSaveID C(9))
   ENDIF       
   
   INSERT INTO SaveState FROM MEMVAR
   SAVE TO MEMO SaveState.mMemvars ALL EXCEPT g*
   RETURN
   
   
PROCEDURE PrintRpt
   PARAMETER rptname
   
   m.str = "Select Printer Options"
   m.buttons = "\<Print;P\<review;Cancel"
   m.action = ""
   
   DO Alert WITH m.str, m.buttons, m.action, " Print Select ",.F., .F., .F., .F., "INFO"      

   DO CASE
      CASE m.action = "Print"
           REPORT FORM (m.rptname) TO PRINT NOCONSOLE
           
      CASE m.action = "Preview"
           REPORT FORM (m.rptname) PREVIEW
           
   ENDCASE
   
   RETURN             